diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/Makefile.am newlib-1.20.0/newlib/libc/machine/arm/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/machine/arm/Makefile.am	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/Makefile.am	2012-03-28 10:11:12.259138686 +0200
@@ -8,9 +8,7 @@
 
 noinst_LIBRARIES = lib.a
 
-lib_a_SOURCES = setjmp.S access.c strlen.c strcmp.c strcpy.c \
-	        memcpy.S memcpy-stub.c memchr-stub.c memchr.S \
-		strlen.c strlen-armv7.S
+lib_a_SOURCES = setjmp.S access.c strlen.c strcmp.c strcpy.c
 lib_a_CCASFLAGS=$(AM_CCASFLAGS)
 lib_a_CFLAGS = $(AM_CFLAGS)
 
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/arm/strlen.c newlib-1.20.0/newlib/libc/machine/arm/strlen.c
--- newlib-1.20.0.orig/newlib/libc/machine/arm/strlen.c	2011-10-18 13:35:17.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/arm/strlen.c	2012-03-28 10:11:12.262138731 +0200
@@ -60,8 +60,6 @@
 }
 #else
 
-#if !(defined(_ISA_ARM_7) || defined(__ARM_ARCH_6T2__))
-
 size_t __attribute__((naked))
 strlen (const char* str)
 {
@@ -180,4 +178,3 @@
        "RETURN");
 }
 #endif
-#endif
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/configure.in newlib-1.20.0/newlib/libc/machine/configure.in
--- newlib-1.20.0.orig/newlib/libc/machine/configure.in	2011-11-29 07:33:49.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/configure.in	2012-03-28 10:11:12.267138811 +0200
@@ -31,6 +31,7 @@
 	crx) AC_CONFIG_SUBDIRS(crx) ;;
 	d10v) AC_CONFIG_SUBDIRS(d10v) ;;
 	d30v) AC_CONFIG_SUBDIRS(d30v) ;;
+	epiphany) AC_CONFIG_SUBDIRS(epiphany) ;;
 	fr30) AC_CONFIG_SUBDIRS(fr30) ;;
 	frv) AC_CONFIG_SUBDIRS(frv) ;;
 	h8300) AC_CONFIG_SUBDIRS(h8300) ;;
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/epiphany/configure.in newlib-1.20.0/newlib/libc/machine/epiphany/configure.in
--- newlib-1.20.0.orig/newlib/libc/machine/epiphany/configure.in	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/epiphany/configure.in	2012-03-28 10:11:12.276138950 +0200
@@ -0,0 +1,41 @@
+dnl This is the newlib/libc/machine/epiphany configure.in file.
+
+dnl Copyright (c) 2011, 2012 Adapteva, Inc.
+dnl All rights reserved.
+
+dnl Redistribution and use in source and binary forms, with or without
+dnl modification, are permitted provided that the following conditions are met:
+dnl  * Redistributions of source code must retain the above copyright notice,
+dnl    this list of conditions and the following disclaimer.
+dnl  * Redistributions in binary form must reproduce the above copyright
+dnl    notice, this list of conditions and the following disclaimer in the
+dnl    documentation and/or other materials provided with the distribution.
+dnl  * Neither the name of Adapteva nor the names of its contributors may be
+dnl    used to endorse or promote products derived from this software without
+dnl    specific prior written permission.
+
+dnl THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+dnl AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+dnl IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+dnl ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+dnl LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+dnl CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+dnl SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+dnl INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+dnl CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+dnl ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+dnl POSSIBILITY OF SUCH DAMAGE.
+
+dnl Process this file with autoconf to produce a configure script.
+
+AC_PREREQ(2.59)
+AC_INIT([newlib],[NEWLIB_VERSION])
+AC_CONFIG_SRCDIR([Makefile.am])
+
+dnl Can't be done in NEWLIB_CONFIGURE because that confuses automake.
+AC_CONFIG_AUX_DIR(../../../..)
+
+NEWLIB_CONFIGURE(../../..)
+
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/epiphany/machine/stdlib.h newlib-1.20.0/newlib/libc/machine/epiphany/machine/stdlib.h
--- newlib-1.20.0.orig/newlib/libc/machine/epiphany/machine/stdlib.h	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/epiphany/machine/stdlib.h	2012-03-28 10:11:12.276138950 +0200
@@ -0,0 +1,15 @@
+static __inline__ long int
+random (void)
+{
+  extern int rand(void);
+
+  return rand ();
+}
+
+static __inline__ void
+srandom (unsigned int seed)
+{
+  void srand(unsigned int seed);
+
+  srand (seed);
+}
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/epiphany/Makefile.am newlib-1.20.0/newlib/libc/machine/epiphany/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/machine/epiphany/Makefile.am	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/epiphany/Makefile.am	2012-03-28 10:11:12.268138826 +0200
@@ -0,0 +1,42 @@
+## Copyright (c) 2011, Adapteva, Inc.
+## All rights reserved.
+
+## Redistribution and use in source and binary forms, with or without
+## modification, are permitted provided that the following conditions are met:
+##  * Redistributions of source code must retain the above copyright notice,
+##    this list of conditions and the following disclaimer.
+##  * Redistributions in binary form must reproduce the above copyright
+##    notice, this list of conditions and the following disclaimer in the
+##    documentation and/or other materials provided with the distribution.
+##  * Neither the name of Adapteva nor the names of its contributors may be
+##    used to endorse or promote products derived from this software without
+##    specific prior written permission.
+
+## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+## ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+## POSSIBILITY OF SUCH DAMAGE.
+
+## Process this file with automake to generate Makefile.in
+
+AUTOMAKE_OPTIONS = cygnus
+
+INCLUDES = $(NEWLIB_CFLAGS) $(CROSS_CFLAGS) $(TARGET_CFLAGS)
+
+AM_CCASFLAGS = $(INCLUDES)
+
+noinst_LIBRARIES = lib.a
+
+lib_a_SOURCES = setjmp.S
+lib_a_CCASFLAGS=$(AM_CCASFLAGS)
+lib_a_CFLAGS = $(AM_CFLAGS)
+
+ACLOCAL_AMFLAGS = -I ../../.. -I ../../../..
+CONFIG_STATUS_DEPENDENCIES = $(newlib_basedir)/configure.host
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/epiphany/setjmp.S newlib-1.20.0/newlib/libc/machine/epiphany/setjmp.S
--- newlib-1.20.0.orig/newlib/libc/machine/epiphany/setjmp.S	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/epiphany/setjmp.S	2012-03-28 10:11:12.277138965 +0200
@@ -0,0 +1,65 @@
+/* setjmp and longjmp
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+	.file "setjmp.S"
+        .section .text
+        .align 4
+	.global  _setjmp
+        .type _setjmp, %function
+_setjmp:
+	strd lr,[r0]
+	strd r4,[r0,1]
+	strd r6,[r0,2]
+	strd r8,[r0,3]
+	strd r10,[r0,4]
+	strd r32,[r0,5]
+	strd r34,[r0,6]
+	strd r36,[r0,7]
+	strd r38,[r0,8]
+	str sp,[r0,18]
+	mov r0,#0
+	rts
+	.size _setjmp, .-_setjmp
+
+	.global _longjmp
+_longjmp:
+	ldrd lr,[r0] ; return address / r15
+	ldrd r4,[r0,1]
+	ldrd r6,[r0,2]
+	ldrd r8,[r0,3]
+	ldrd r10,[r0,4]
+	ldrd r32,[r0,5]
+	ldrd r34,[r0,6]
+	ldrd r36,[r0,7]
+	ldrd r38,[r0,8]
+	ldr sp,[r0,18]
+	sub r1,r1,0
+	mov r0,#1
+	movne r0,r1
+	jr lr
+        .size   _longjmp, .-_longjmp
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/i386/setjmp.S newlib-1.20.0/newlib/libc/machine/i386/setjmp.S
--- newlib-1.20.0.orig/newlib/libc/machine/i386/setjmp.S	2010-11-16 18:52:21.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/i386/setjmp.S	2012-03-28 10:11:12.277138965 +0200
@@ -8,7 +8,7 @@
  * Copyright (C) 1991 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/m68k/memcpy.S newlib-1.20.0/newlib/libc/machine/m68k/memcpy.S
--- newlib-1.20.0.orig/newlib/libc/machine/m68k/memcpy.S	2010-02-08 18:24:22.000000000 +0100
+++ newlib-1.20.0/newlib/libc/machine/m68k/memcpy.S	2012-03-28 10:11:12.277138965 +0200
@@ -15,7 +15,7 @@
 
 #include "m68kasm.h"
 
-#if defined (__mcoldfire__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
+#if defined (__mcoldfire__) || defined (__mcpu32__) || defined (__mc68010__) || defined (__mc68020__) || defined (__mc68030__) || defined (__mc68040__) || defined (__mc68060__)
 # define MISALIGNED_OK 1
 #else
 # define MISALIGNED_OK 0
diff -Naur newlib-1.20.0.orig/newlib/libc/machine/powerpc/Makefile.am newlib-1.20.0/newlib/libc/machine/powerpc/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/machine/powerpc/Makefile.am	2007-05-24 19:33:35.000000000 +0200
+++ newlib-1.20.0/newlib/libc/machine/powerpc/Makefile.am	2012-03-28 10:11:12.278138980 +0200
@@ -10,7 +10,7 @@
 
 AM_CFLAGS = -I $(srcdir)/../../stdio -I $(srcdir)/../../stdlib
 
-lib_a_SOURCES = setjmp.S times.c
+lib_a_SOURCES = setjmp.S
 lib_a_CCASFLAGS=$(AM_CCASFLAGS)
 lib_a_CFLAGS=$(AM_CFLAGS)
 lib_a_LIBADD = @extra_objs@
diff -Naur newlib-1.20.0.orig/newlib/libc/Makefile.am newlib-1.20.0/newlib/libc/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/Makefile.am	2011-01-05 18:18:16.000000000 +0100
+++ newlib-1.20.0/newlib/libc/Makefile.am	2012-03-28 10:11:12.247138497 +0200
@@ -36,6 +36,8 @@
 
 if HAVE_XDR_DIR
 XDR_SUBDIR = xdr
+rpcincludedir = $(tooldir)
+nobase_rpcinclude_HEADERS = include/rpc/xdr.h include/rpc/types.h
 endif
 
 # The order of SUBDIRS is important for the integrated documentation.
diff -Naur newlib-1.20.0.orig/newlib/libc/misc/__dprintf.c newlib-1.20.0/newlib/libc/misc/__dprintf.c
--- newlib-1.20.0.orig/newlib/libc/misc/__dprintf.c	2008-12-11 18:27:55.000000000 +0100
+++ newlib-1.20.0/newlib/libc/misc/__dprintf.c	2012-03-28 10:11:12.278138980 +0200
@@ -5,6 +5,7 @@
 */
 
 #include <_ansi.h>
+#include <stdint.h>
 #include "ctype.h"
 #include "reent.h"
 #include "string.h"
@@ -131,7 +132,7 @@
 	      write_string (unctrl (c));
 	      break;
 	    case 'p' :
-	      l = (_POINTER_INT) va_arg (args, char *);
+	      l = (intptr_t) va_arg (args, char *);
 	      print_number (16, 1, l);
 	      break;
 	    case 'd' :
diff -Naur newlib-1.20.0.orig/newlib/libc/posix/readdir.c newlib-1.20.0/newlib/libc/posix/readdir.c
--- newlib-1.20.0.orig/newlib/libc/posix/readdir.c	2003-06-06 21:57:51.000000000 +0200
+++ newlib-1.20.0/newlib/libc/posix/readdir.c	2012-03-28 10:11:12.279138996 +0200
@@ -37,6 +37,7 @@
 static char sccsid[] = "@(#)readdir.c	5.7 (Berkeley) 6/1/90";
 #endif /* LIBC_SCCS and not lint */
 
+#include <stdint.h>
 #include <dirent.h>
 
 extern int getdents (int fd, void *dp, int count);
@@ -75,7 +76,7 @@
       continue;
     }
     dp = (struct dirent *)(dirp->dd_buf + dirp->dd_loc);
-    if ((int)dp & 03) {	/* bogus pointer check */
+    if ((intptr_t)dp & 03) {	/* bogus pointer check */
 #ifdef HAVE_DD_LOCK
       __lock_release_recursive(dirp->dd_lock);
 #endif
diff -Naur newlib-1.20.0.orig/newlib/libc/posix/readdir_r.c newlib-1.20.0/newlib/libc/posix/readdir_r.c
--- newlib-1.20.0.orig/newlib/libc/posix/readdir_r.c	2003-06-06 21:57:51.000000000 +0200
+++ newlib-1.20.0/newlib/libc/posix/readdir_r.c	2012-03-28 10:11:12.279138996 +0200
@@ -76,7 +76,7 @@
         __lock_release_recursive(dirp->dd_lock);
 #endif
         *dpp = NULL;
-        return errno;
+        return dirp->dd_size == 0 ? 0 : errno;
       }
     }
     if (dirp->dd_loc >= dirp->dd_size) {
diff -Naur newlib-1.20.0.orig/newlib/libc/search/db_local.h newlib-1.20.0/newlib/libc/search/db_local.h
--- newlib-1.20.0.orig/newlib/libc/search/db_local.h	2010-03-05 09:55:15.000000000 +0100
+++ newlib-1.20.0/newlib/libc/search/db_local.h	2012-03-28 10:11:12.279138996 +0200
@@ -102,11 +102,11 @@
 typedef struct __db {
 	DBTYPE type;			/* Underlying db type. */
 	int (*close)(struct __db *);
-	int (*del)(const struct __db *, const DBT *, u_int);
-	int (*get)(const struct __db *, const DBT *, DBT *, u_int);
-	int (*put)(const struct __db *, DBT *, const DBT *, u_int);
-	int (*seq)(const struct __db *, DBT *, DBT *, u_int);
-	int (*sync)(const struct __db *, u_int);
+	int (*del)(const struct __db *, const DBT *, __uint32_t);
+	int (*get)(const struct __db *, const DBT *, DBT *, __uint32_t);
+	int (*put)(const struct __db *, DBT *, const DBT *, __uint32_t);
+	int (*seq)(const struct __db *, DBT *, DBT *, __uint32_t);
+	int (*sync)(const struct __db *, __uint32_t);
 	void *internal;			/* Access method private. */
 	int (*fd)(const struct __db *);
 } DB;
diff -Naur newlib-1.20.0.orig/newlib/libc/search/extern.h newlib-1.20.0/newlib/libc/search/extern.h
--- newlib-1.20.0.orig/newlib/libc/search/extern.h	2002-06-20 21:51:31.000000000 +0200
+++ newlib-1.20.0/newlib/libc/search/extern.h	2012-03-28 10:11:12.279138996 +0200
@@ -43,7 +43,7 @@
 int	 __big_split(HTAB *, BUFHEAD *, BUFHEAD *, BUFHEAD *,
 		int, __uint32_t, SPLIT_RETURN *);
 int	 __buf_free(HTAB *, int, int);
-void	 __buf_init(HTAB *, int);
+void	 __buf_init(HTAB *, __uint32_t);
 __uint32_t	 __call_hash(HTAB *, char *, int);
 int	 __delpair(HTAB *, BUFHEAD *, int);
 int	 __expand_table(HTAB *);
diff -Naur newlib-1.20.0.orig/newlib/libc/search/hash_buf.c newlib-1.20.0/newlib/libc/search/hash_buf.c
--- newlib-1.20.0.orig/newlib/libc/search/hash_buf.c	2004-05-26 19:57:10.000000000 +0200
+++ newlib-1.20.0/newlib/libc/search/hash_buf.c	2012-03-28 10:11:12.280139012 +0200
@@ -118,7 +118,7 @@
 	int newpage;	/* If prev_bp set, indicates a new overflow page. */
 {
 	BUFHEAD *bp;
-	__uint32_t is_disk_mask;
+	ptrdiff_t is_disk_mask;
 	int is_disk, segment_ndx;
 	SEGMENT segp;
 
@@ -298,7 +298,7 @@
 extern void
 __buf_init(hashp, nbytes)
 	HTAB *hashp;
-	int nbytes;
+	__uint32_t nbytes;
 {
 	BUFHEAD *bfp;
 	int npages;
diff -Naur newlib-1.20.0.orig/newlib/libc/search/hash.h newlib-1.20.0/newlib/libc/search/hash.h
--- newlib-1.20.0.orig/newlib/libc/search/hash.h	2008-07-02 20:38:45.000000000 +0200
+++ newlib-1.20.0/newlib/libc/search/hash.h	2012-03-28 10:11:12.280139012 +0200
@@ -82,7 +82,7 @@
 
 /* Hash Table Information */
 typedef struct hashhdr {		/* Disk resident portion */
-	int		magic;		/* Magic NO for hash tables */
+	__uint32_t	magic;		/* Magic NO for hash tables */
 	int		version;	/* Version ID */
 	__uint32_t	lorder;		/* Byte Order */
 	int		bsize;		/* Bucket/Page Size */
@@ -97,7 +97,7 @@
 	int		high_mask;	/* Mask to modulo into entire table */
 	int		low_mask;	/* Mask to modulo into lower half of 
 					 * table */
-	int		ffactor;	/* Fill factor */
+	__uint32_t	ffactor;	/* Fill factor */
 	int		nkeys;		/* Number of keys in hash table */
 	int		hdrpages;	/* Size of table header */
 	int		h_charkey;	/* value of hash(CHARKEY) */
diff -Naur newlib-1.20.0.orig/newlib/libc/search/hcreate_r.c newlib-1.20.0/newlib/libc/search/hcreate_r.c
--- newlib-1.20.0.orig/newlib/libc/search/hcreate_r.c	2002-07-03 02:33:57.000000000 +0200
+++ newlib-1.20.0/newlib/libc/search/hcreate_r.c	2012-03-28 10:11:12.280139012 +0200
@@ -123,9 +123,10 @@
 void
 hdestroy_r(struct hsearch_data *htab)
 {
+#if 0
 	struct internal_entry *ie;
 	size_t idx;
-
+#endif
 	if (htab->htable == NULL)
 		return;
 
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/fvwrite.c newlib-1.20.0/newlib/libc/stdio/fvwrite.c
--- newlib-1.20.0.orig/newlib/libc/stdio/fvwrite.c	2011-06-14 05:56:05.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdio/fvwrite.c	2012-03-28 10:11:12.281139028 +0200
@@ -155,8 +155,10 @@
 							 newsize);
 		      if (!str)
 			{
-			  /* Free buffer which is no longer used.  */
+			  /* Free buffer which is no longer used and clear
+			     __SMBF flag to avoid double free in fclose.  */
 			  _free_r (ptr, fp->_bf._base);
+			  fp->_flags &=  ~__SMBF;
 			  /* Ensure correct errno, even if free changed it.  */
 			  ptr->_errno = ENOMEM;
 			  goto err;
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/open_memstream.c newlib-1.20.0/newlib/libc/stdio/open_memstream.c
--- newlib-1.20.0.orig/newlib/libc/stdio/open_memstream.c	2011-01-05 18:38:42.000000000 +0100
+++ newlib-1.20.0/newlib/libc/stdio/open_memstream.c	2012-03-28 10:11:12.281139028 +0200
@@ -330,9 +330,9 @@
     c->max *= sizeof(wchar_t);
   if (c->max < 64)
     c->max = 64;
-#if (SIZE_MAX >= 64 * 1024)
-  else if (c->max > 64 * 1024)
-    c->max = 64 * 1024;
+#if (SIZE_MAX >= 0x10000)
+  else if (c->max > 0x10000)
+    c->max = 0x10000;
 #endif
   *size = 0;
   *buf = _malloc_r (ptr, c->max);
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/sprintf.c newlib-1.20.0/newlib/libc/stdio/sprintf.c
--- newlib-1.20.0.orig/newlib/libc/stdio/sprintf.c	2009-03-12 11:27:10.000000000 +0100
+++ newlib-1.20.0/newlib/libc/stdio/sprintf.c	2012-03-28 10:11:12.281139028 +0200
@@ -518,6 +518,10 @@
 			implementation is similar to <<%#tx>>), except
 			that <<0x>> appears even for the NULL pointer.
 
+		o m
+			Prints the output of <<strerror(errno)>>; no
+			argument is required.  A GNU extension.
+
 		o-
 	O-
 
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/swprintf.c newlib-1.20.0/newlib/libc/stdio/swprintf.c
--- newlib-1.20.0.orig/newlib/libc/stdio/swprintf.c	2009-03-12 11:27:10.000000000 +0100
+++ newlib-1.20.0/newlib/libc/stdio/swprintf.c	2012-03-28 10:11:12.282139044 +0200
@@ -498,6 +498,10 @@
 			implementation is similar to <<%#tx>>), except
 			that <<0x>> appears even for the NULL pointer.
 
+		o m
+			Prints the output of <<strerror(errno)>>; no
+			argument is required.  A GNU extension.
+
 		o-
 	O-
 
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/tmpnam.c newlib-1.20.0/newlib/libc/stdio/tmpnam.c
--- newlib-1.20.0.orig/newlib/libc/stdio/tmpnam.c	2004-04-23 22:01:55.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdio/tmpnam.c	2012-03-28 10:11:12.282139044 +0200
@@ -94,11 +94,13 @@
 #include <_ansi.h>
 #include <reent.h>
 #include <stdio.h>
+#include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
 #include <fcntl.h>
 #include <reent.h>
 #include <errno.h>
+#include <inttypes.h>
 
 /* Try to open the file specified, if it can't be opened then try
    another one.  Return nonzero if successful, otherwise zero.  */
@@ -109,7 +111,7 @@
        char *result       _AND
        _CONST char *part1 _AND
        _CONST char *part2 _AND
-       int part3          _AND
+       intptr_t part3     _AND
        int *part4)
 {
   /*  Generate the filename and make sure that there isn't one called
@@ -118,7 +120,7 @@
   while (1)
     {
       int t;
-      _sprintf_r (ptr, result, "%s/%s%x.%x", part1, part2, part3, *part4);
+      _sprintf_r (ptr, result, "%s/%s%" PRIxPTR ".%x", part1, part2, part3, *part4);
       (*part4)++;
       t = _open_r (ptr, result, O_RDONLY, 0);
       if (t == -1)
@@ -183,7 +185,7 @@
   if (filename)
     {
       if (! worker (p, filename, dir, prefix,
-		    _getpid_r (p) ^ (int) (_POINTER_INT) p, &p->_inc))
+		    _getpid_r (p) ^ (intptr_t) p, &p->_inc))
 	return NULL;
     }
   return filename;
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/vfprintf.c newlib-1.20.0/newlib/libc/stdio/vfprintf.c
--- newlib-1.20.0.orig/newlib/libc/stdio/vfprintf.c	2010-02-15 17:10:28.000000000 +0100
+++ newlib-1.20.0/newlib/libc/stdio/vfprintf.c	2012-03-28 10:11:12.283139060 +0200
@@ -114,7 +114,7 @@
 
 #if defined(LIBC_SCCS) && !defined(lint)
 /*static char *sccsid = "from: @(#)vfprintf.c	5.50 (Berkeley) 12/16/92";*/
-static char *rcsid = "$Id: vfprintf.c,v 1.43 2002/08/13 02:40:06 fitzsim Exp $";
+static char *rcsid = "$Id$";
 #endif /* LIBC_SCCS and not lint */
 
 /*
@@ -1225,6 +1225,15 @@
 				sign = '-';
 			break;
 #endif /* FLOATING_POINT */
+#ifdef _GLIBC_EXTENSION
+		case 'm':  /* extension */
+			{
+				int dummy;
+				cp = _strerror_r (data, data->_errno, 1, &dummy);
+			}
+			flags &= ~LONGINT;
+			goto string;
+#endif
 		case 'n':
 #ifndef _NO_LONGLONG
 			if (flags & QUADINT)
@@ -1272,8 +1281,11 @@
 #ifdef _WANT_IO_C99_FORMATS
 		case 'S':
 #endif
-			sign = '\0';
 			cp = GET_ARG (N, ap, char_ptr_t);
+#ifdef _GLIBC_EXTENSION
+string:
+#endif
+			sign = '\0';
 #ifndef __OPTIMIZE_SIZE__
 			/* Behavior is undefined if the user passed a
 			   NULL string when precision is not 0.
diff -Naur newlib-1.20.0.orig/newlib/libc/stdio/vfwprintf.c newlib-1.20.0/newlib/libc/stdio/vfwprintf.c
--- newlib-1.20.0.orig/newlib/libc/stdio/vfwprintf.c	2011-07-15 19:20:16.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdio/vfwprintf.c	2012-03-28 10:11:12.284139075 +0200
@@ -1074,6 +1074,15 @@
 				sign = L'-';
 			break;
 #endif /* FLOATING_POINT */
+#ifdef _GLIBC_EXTENSION
+		case L'm':  /* GNU extension */
+			{
+				int dummy;
+				cp = (wchar_t *) _strerror_r (data, data->_errno, 1, &dummy);
+			}
+			flags &= ~LONGINT;
+			goto string;
+#endif
 		case L'n':
 #ifndef _NO_LONGLONG
 			if (flags & QUADINT)
@@ -1118,8 +1127,11 @@
 #ifdef _WANT_IO_C99_FORMATS
 		case L'S':	/* POSIX extension */
 #endif
-			sign = '\0';
 			cp = GET_ARG (N, ap, wchar_ptr_t);
+#ifdef _GLIBC_EXTENSION
+string:
+#endif
+			sign = '\0';
 #ifndef __OPTIMIZE_SIZE__
 			/* Behavior is undefined if the user passed a
 			   NULL string when precision is not 0.
@@ -1132,7 +1144,7 @@
 			else
 #endif /* __OPTIMIZE_SIZE__ */
 #ifdef _MB_CAPABLE
-			if (ch == L's' && !(flags & LONGINT)) {
+			if (ch != L'S' && !(flags & LONGINT)) {
 				char *arg = (char *) cp;
 				size_t insize = 0, nchars = 0, nconv = 0;
 				mbstate_t ps;
diff -Naur newlib-1.20.0.orig/newlib/libc/stdlib/__atexit.c newlib-1.20.0/newlib/libc/stdlib/__atexit.c
--- newlib-1.20.0.orig/newlib/libc/stdlib/__atexit.c	2010-04-06 22:20:36.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdlib/__atexit.c	2012-03-28 10:11:12.285139090 +0200
@@ -74,7 +74,7 @@
 	  if (args == NULL)
 	    {
 #ifndef __SINGLE_THREAD__
-	      __lock_release(lock);
+	      __lock_release(__atexit_lock);
 #endif
 	      return -1;
 	    }
diff -Naur newlib-1.20.0.orig/newlib/libc/stdlib/atof.c newlib-1.20.0/newlib/libc/stdlib/atof.c
--- newlib-1.20.0.orig/newlib/libc/stdlib/atof.c	2003-10-20 20:46:37.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdlib/atof.c	2012-03-28 10:11:12.285139090 +0200
@@ -1,6 +1,6 @@
 /*
 FUNCTION
-   <<atof>>, <<atoff>>---string to double or float
+   <<atof>> ---string to double
 
 INDEX
 	atof
@@ -10,19 +10,14 @@
 ANSI_SYNOPSIS
 	#include <stdlib.h>
         double atof(const char *<[s]>);
-        float atoff(const char *<[s]>);
 
 TRAD_SYNOPSIS
 	#include <stdlib.h>
         double atof(<[s]>)
         char *<[s]>;
 
-        float atoff(<[s]>)
-        char *<[s]>;
-
 DESCRIPTION
 <<atof>> converts the initial portion of a string to a <<double>>.
-<<atoff>> converts the initial portion of a string to a <<float>>.
 
 The functions parse the character string <[s]>,
 locating a substring which can be converted to a floating-point
@@ -36,7 +31,6 @@
 something other than <<+>>, <<->>, <<.>>, or a digit.
 
 <<atof(<[s]>)>> is implemented as <<strtod(<[s]>, NULL)>>.
-<<atoff(<[s]>)>> is implemented as <<strtof(<[s]>, NULL)>>.
 
 RETURNS
 <<atof>> returns the converted substring value, if any, as a
@@ -47,12 +41,9 @@
 If the correct value would cause underflow, <<0.0>> is returned
 and <<ERANGE>> is stored in <<errno>>.
 
-<<atoff>> obeys the same rules as <<atof>>, except that it
-returns a <<float>>.
-
 PORTABILITY
-<<atof>> is ANSI C. <<atof>>, <<atoi>>, and <<atol>> are subsumed by <<strod>>
-and <<strol>>, but are used extensively in existing code. These functions are
+<<atof>> is ANSI C. <<atof>>, <<atoi>>, and <<atol>> are subsumed by <<strtod>>
+and <<strtol>>, but are used extensively in existing code. These functions are
 less reliable, but may be faster if the argument is verified to be in a valid
 range.
 
diff -Naur newlib-1.20.0.orig/newlib/libc/stdlib/Makefile.am newlib-1.20.0/newlib/libc/stdlib/Makefile.am
--- newlib-1.20.0.orig/newlib/libc/stdlib/Makefile.am	2009-04-16 20:24:35.000000000 +0200
+++ newlib-1.20.0/newlib/libc/stdlib/Makefile.am	2012-03-28 10:11:12.284139075 +0200
@@ -16,7 +16,6 @@
 	assert.c  	\
 	atexit.c	\
 	atof.c 		\
-	atoff.c		\
 	atoi.c  	\
 	atol.c		\
 	calloc.c	\
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memccpy.c newlib-1.20.0/newlib/libc/string/memccpy.c
--- newlib-1.20.0.orig/newlib/libc/string/memccpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/memccpy.c	2012-03-28 10:11:12.286139105 +0200
@@ -35,13 +35,14 @@
 	*/
 
 #include <_ansi.h>
+#include <stdint.h>
 #include <stddef.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the word copy loop.  */
 #define LITTLEBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memchr.c newlib-1.20.0/newlib/libc/string/memchr.c
--- newlib-1.20.0.orig/newlib/libc/string/memchr.c	2008-05-27 01:31:08.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/memchr.c	2012-03-28 10:11:12.286139105 +0200
@@ -38,10 +38,11 @@
 
 #include <_ansi.h>
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
-#define UNALIGNED(X) ((long)X & (sizeof (long) - 1))
+#define UNALIGNED(X) ((intptr_t)X & (sizeof (long) - 1))
 
 /* How many bytes are loaded each iteration of the word copy loop.  */
 #define LBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memcmp.c newlib-1.20.0/newlib/libc/string/memcmp.c
--- newlib-1.20.0.orig/newlib/libc/string/memcmp.c	2005-03-06 21:40:05.000000000 +0100
+++ newlib-1.20.0/newlib/libc/string/memcmp.c	2012-03-28 10:11:12.286139105 +0200
@@ -37,11 +37,11 @@
 */
 
 #include <string.h>
-
+#include <stdint.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the word copy loop.  */
 #define LBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memcpy.c newlib-1.20.0/newlib/libc/string/memcpy.c
--- newlib-1.20.0.orig/newlib/libc/string/memcpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/memcpy.c	2012-03-28 10:11:12.286139105 +0200
@@ -34,11 +34,12 @@
 	*/
 
 #include <_ansi.h>
+#include <stdint.h>
 #include <string.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memmove.c newlib-1.20.0/newlib/libc/string/memmove.c
--- newlib-1.20.0.orig/newlib/libc/string/memmove.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/memmove.c	2012-03-28 10:11:12.287139121 +0200
@@ -36,13 +36,14 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <_ansi.h>
 #include <stddef.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.20.0.orig/newlib/libc/string/mempcpy.c newlib-1.20.0/newlib/libc/string/mempcpy.c
--- newlib-1.20.0.orig/newlib/libc/string/mempcpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/mempcpy.c	2012-03-28 10:11:12.287139121 +0200
@@ -34,10 +34,11 @@
 #include <stddef.h>
 #include <limits.h>
 #include <string.h>
+#include <stdint.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((uintptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.20.0.orig/newlib/libc/string/memset.c newlib-1.20.0/newlib/libc/string/memset.c
--- newlib-1.20.0.orig/newlib/libc/string/memset.c	2008-05-27 20:44:40.000000000 +0200
+++ newlib-1.20.0/newlib/libc/string/memset.c	2012-03-28 10:11:12.287139121 +0200
@@ -34,9 +34,10 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 
 #define LBLOCKSIZE (sizeof(long))
-#define UNALIGNED(X)   ((long)X & (LBLOCKSIZE - 1))
+#define UNALIGNED(X)   ((intptr_t)X & (LBLOCKSIZE - 1))
 #define TOO_SMALL(LEN) ((LEN) < LBLOCKSIZE)
 
 _PTR
